LibreOffice: XCloseListener Interface Reference

LibreOffice LibreOffice 26.8 SDK API Reference

Loading...
Searching...
No Matches
XCloseListener Interface Referencepublished

makes it possible to receive events when an object is called for closing More...

`import "XCloseListener.idl";`

Inheritance diagram for XCloseListener:

## Public Member Functions
void | queryClosing ([in] com::sun::star::lang::EventObject Source, [in] boolean GetsOwnership) raises ( CloseVetoException )
| is called when somewhere tries to close listened object
void | notifyClosing ([in] com::sun::star::lang::EventObject Source)
| is called when the listened object is closed really
Public Member Functions inherited from XEventListener
void | disposing ([in] com::sun::star::lang::EventObject Source)
| gets called when the broadcaster is about to be disposed.
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.

## Detailed Description

makes it possible to receive events when an object is called for closing

Such close events are broadcasted by a XCloseBroadcaster if somewhere tries to close it by calling XCloseable::close(). Listener can:

- break that by throwing CloseVetoException
- or accept that by deregister himself at this broadcaster.

If an event com::sun::star::lang::XEventListener::disposing() occurred, nobody called XCloseable::close() on listened object before. Then it's not allowed to break this request - it must be accepted!

See also
  XCloseable
  XCloseBroadcaster

Developers Guide
  Office Development - Closing Documents

## Member Function Documentation

## ◆ notifyClosing()

void notifyClosing | ( | [in] com::sun::star::lang::EventObject | Source | ) |

is called when the listened object is closed really

Now the listened object is closed really. Listener has to accept that; should deregister himself and release all references to it. It's not allowed nor possible to disagree with that by throwing any exception.

If the event com::sun::star::lang::XEventListener::disposing() occurred before it must be accepted too. There exist no chance for a disagreement any more.

Parameters

  Source | describes the source of the event (must be the listened object)

## ◆ queryClosing()

void queryClosing | ( | [in] com::sun::star::lang::EventObject | Source,
|  | [in] boolean | GetsOwnership )
raises | ( | CloseVetoException ) |  |  |

is called when somewhere tries to close listened object

Is called before XCloseListener::notifyClosing(). Listener has the chance to break that by throwing a CloseVetoException. This exception must be passed to the original caller of XCloseable::close() without any interaction.

The parameter GetsOwnership regulate who has to try to close the listened object again, if this listener disagree with the request by throwing the exception. If it's set to FALSE the original caller of XCloseable::close() will be the owner in every case. It's not allowed to call close() from this listener then. If it's set to TRUE this listener will be the new owner if he throw the exception, otherwise not! If his still running processes will be finished he must call close() on listened object again then.

If this listener doesn't disagree with th close request it depends from his internal implementation if he deregister himself at the listened object. But normally this must be done in XCloseListener::notifyClosing().

Parameters

  Source | describes the source of the event (must be the listened object)
  GetsOwnership | TRUE pass the ownership to this listener, if he throw the veto exception (otherwise this parameter must be ignored!) FALSE forbids to grab the ownership for the listened close object and call close() on that any time.

Exceptions

  CloseVetoException | if listener disagree with the close request on listened object he must throw this exception

The documentation for this interface was generated from the following file:

- com/sun/star/util/XCloseListener.idl